# Domande Reti 🌐

## Slide

### Domanda 1

Definire il concetto di protocollo e poi spiegare come funziona un protocollo
particolare a scelta.

Perché gli standard sono importanti nei protocolli?

### Risposta

>Definire il concetto di protocollo e poi spiegare come funziona un protocollo
particolare a scelta.

Un protocollo è una serie di regole che due dispositivi (comunemente chiamati host)
utilizzano per comunicare.
Possiamo prendere come analogia la lingua italiana, infatti due persone
comunicano utilizzando un protocollo (vocaboli che entrambe le persone
capiscono, frasi strutturate in uno specifico modo, etc...).
In questo modo entrambe le persone riescono a capire reciprocamente
cosa si stanno dicendo.

Entriamo più nello specifico analizzando il protocollo HTTP.
In questo protocollo troviamo un client (ovvero un utente
che sta utilizzando un browser e sta facendo una
richiesta per accedere ad una determinata pagina) ed un
server (ovvero colui che fornirà, se presente, la pagina richiesta).

In particolare quando un client fa una richiesta ad un server
sta avvenendo una `HTTP Request`. All'interno di questa richiesta
sono contenute varie informazioni, tra cui:

+ il tipo di richiesta (GET, POST, ...);

+ l'URL della pagina che viene richiesta;

+ il browser;

+ ed ulterioriori informazioni.

La risposta ad una `HTTP Request` viene chiamata `HTTP Response`, dove
troveremo le informazioni che il server ci ha fornito.
In particolare troviamo:

+ lo status code, ovvero un codice identificativo per sapere se
la richiesta è andata a buon fine oppure no;

+ lo stato della connessione, se è ancora aperta o se è chiusa;

+ il codice HTML della pagina richiesta;

+ ed ulterioriori informazioni.

>Perché gli standard sono importanti nei protocolli?

Gli standard nei protocolli sono importanti perché ci permettono di
avere una comunicazione sensata e mai incerta. Per questo motivo i
protocolli hanno una sintassi molto rigida.

### Domanda 2

Quale vantaggio presenta una rete a commutazione di circuito
rispetto ad una a commutazione di pacchetto?

Quali vantaggi ha TDM rispetto a FDM in una rete a commutazione di circuito?

### Risposta

>Quale vantaggio presenta una rete a commutazione di circuito
rispetto ad una a commutazione di pacchetto?

Un grosso vantaggio della rete a commutazione di circuito è che la
bandwith è garantita. Per avere questo vantaggio però dobbiamo
prenotare la connessione tra i due host e tenendola occupata.
Anche se non avvienisse nessuno scambio di informazioni finché
è la connessione è presente rimane prenotata, togliendo la possibilità
ad altri host di comunicare con i due host prenotati.

>Quali vantaggi ha TDM rispetto a FDM in una rete a commutazione di circuito?

+ TDM (Time Devision Multiplexing): la suddivisione dei canali avviene
  in periodi di tempo uguali per tutti gli utenti.

+ FDM (Frequency Devision Multiplexing): la suddivisione dei canali avviene
  sulla frequenza del segnale.

Il vantaggio principale del TDM è che quando un utente ha accesso alla connessione
ne ha anche la completa frequenza, dato che non viene condivisa con nessuno.

### Domanda 3

Considerate l’invio di un pacchetto da un host ad un altro lungo un percorso fisso.
Elencate le componenti di ritardo complessivo, indicando quali
sono costanti e quali variabili.

### Risposta

Le componenti che formano il ritardo complessivo sono 4:

+ Nodal Processing ($d_{proc})$: è il tempo che impiega il router ad analizzare
il pacchetto. In particolare controlla se ci sono errori
(facendo il calcolo del checksum), e determinare il link d'uscita
del router. È un tempo costante.

+ Queueing Delay ($d_{queue}$): è il tempo di accodamento, questo avviene perché
  i router utilizzano una politica FIFO, quindi se sono già presenti dei pacchetti
  nel buffer del router il pacchetto appena arrivato dovrà aspettare il suo turno,
  mentre gli altri veranno processati dal router.

  Questo tempo varia in base alla congestione della rete.
  Infatti può essere nullo (per esempio quando il buffer è vuoto)
  oppure tendere ad $\infin$ se la rete è completamente satura.

+ Transimission Delay ($d_{trans}$): è il tempo di trasimissione dato dalla formula
$d_{trans} = \frac{L}{R}$, dove $L$ è la dimensione del pacchetto, ed $R$ è la
bandwidth. Quindi varia in base ad $L$ ed $R$.

+ Propagation Delay ($d_{prop}$): è il tempo di propagazione dei dati in un cavo.
Infatti la trasmssione di un bit da una sorgente $A$ ad una destinazione $B$ si calcola
prendendo la lunghezza del collegamento $\overline{AB}$, che per comodità chiameremo
$d$ diviso la velocità della luce ($3*10^8 m/s$) . Quindi abbiamo $d_{proc} = \frac{d}{s}$.
Questo ritardo varia in base alla lunghezza del cavo, ma è sempre presente.

### Domanda 4

Quanto tempo impiega un pacchetto di lunghezza di $1000 byte$ per propagarsi
su un collegamento lungo $2500 km$, con una velocità di
propagazione di $2.5 \times 10^8 m/s$ e velocità di trasmissione $2Mbps$?

+ Il tempo di trasmissione $T_{TX}$ di un pacchetto su un canale
è il periodo di tempo in cui il trasmettitore è impegnato ad inviare
i bit del pacchetto sul canale. La durata del tempo di
trasmissione è il rapporto tra il numero di bit di cui
è composto il pacchetto e la velocità di
trasmissione sul canale (espressa in bit/s).
+ Il tempo di propagazione $T_P$ è il tempo necessario ad ogni bit (o, più precisamente,
al segnale che lo rappresenta) per percorrere il canale fino al nodo successivo.
La durata del tempo di propagazione dipende esclusivamente
dalla velocità di propagazione del segnale nel mezzo trasmissivo (espressa in m/s)
e dalla lunghezza (espressa in m) del mezzo stesso.

### Risposta

![Soluzione](https://i.imgur.com/bk0242m.png)

### Domanda 5

Il tempo di propagazione dipende dalla lunghezza del pacchetto?
Dipende dalla velocità di trasmissione?

### Risposta

No, il tempo di propagazione non dipende ne dalla lunghezza del pacchetto,
ne dalla velocità di trasmissione. Dipende esclusivamente dalla distanza
del collegamento.

### Domanda 6

Si consideri una topologia di rete lineare composta da un singolo canale con
velocità di trasmissione pari a 1 Mbit/s, come illustrato nella figura.
Il nodo S deve trasmettere un file di dimensione pari a 9500 byte verso il nodo D.
Si ipotizzi che:

+ Non vi siano errori di trasmissione
+ Il tempo di propagazione sul canale sia pari a 5 ms
+ La dimensione massima dei pacchetti trasmessi sul
canale sia pari a 1500 byte (si trascurino le intestazioni)

Determinare il tempo necessario affinché il nodo D riceva completamente il file.
![Foto_Domanda6](https://i.imgur.com/x4oeGuH.png)

### Domanda 7

L’host A vuole inviare un file voluminoso all’Host B.
Il percorso tra l’Host A e l’Host B ha
tre collegamenti con frequenze R1 = 500kbps, R2 = 2Mbps e R3 = 1Mbps, rispettivamente.

+ Assumendo che non vi sia altro traffico nella rete,
qual è il throughput per il trasferimento del file? [circa 286kbps]
+ Se il file è di 4 MByte, dividendo tale grandezza per il throughput,
approssimativamente quanto tempo occorrerà per trasferire il file
all’Host B? [112 s]
+ Rispondere alle precedenti domande supponendo R2 = 100kbps [circa 416s]

